## openclonk 8.0

=== CMakeLists.txt ===
# OpenClonk, http://www.openclonk.org
#
# Copyright (c) 2009-2016, The OpenClonk Team and contributors
#
# Distributed under the terms of the ISC license; see accompanying file
# "COPYING" for details.
#
# "Clonk" is a registered trademark of Matthes Bender, used with permission.
# See accompanying file "TRADEMARK" for details.
#
# To redistribute this file separately, substitute the full license texts
# for the above references.

cmake_minimum_required (VERSION 3.0.2)

# Don't allow people to build "Release" builds because there's no reason to do that.
# Use one of RelWithDebInfo or MinSizeRel instead.
set(CMAKE_CONFIGURATION_TYPES Debug RelWithDebInfo MinSizeRel CACHE STRING "List of supported configuration types." FORCE)

# Set a default build type as the empty build type is without either debug
# symbols or optimizations and thus completely useless.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

project (openclonk CXX C)

# CMP0054: Only interpret if() arguments as variables or keywords when unquoted
# (since CMake 3.1)
if(POLICY CMP0054)
	cmake_policy(SET CMP0054 NEW)
endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(Version)

set(CMAKE_ADDITIONAL_DEPS_PATH "${CMAKE_CURRENT_BINARY_DIR}/deps" CACHE PATH "Additional directory to search for libraries and headers")
list(APPEND CMAKE_PREFIX_PATH ${CMAKE_ADDITIONAL_DEPS_PATH})

############################################################################
# User selectable options
############################################################################
include(CMakeDependentOption)
option(PROJECT_FOLDERS "Put source files into subfolders in project file" ON)
CMAKE_DEPENDENT_OPTION(USE_COCOA         "Use Apple Cocoa widgets." ON "APPLE" OFF)
CMAKE_DEPENDENT_OPTION(USE_WIN32_WINDOWS "Use Microsoft Desktop App User Interface widgets." ON "WIN32" OFF)
CMAKE_DEPENDENT_OPTION(USE_SDL_MAINLOOP  "Use SDL to create windows etc. Qt editor." ON "NOT USE_COCOA AND NOT USE_WIN32_WINDOWS AND NOT HEADLESS_ONLY" OFF)
option(WITH_AUTOMATIC_UPDATE "Automatic updates are downloaded from the project website." OFF)
option(HEADLESS_ONLY "Only build headless parts. Somewhat reduces dependencies. (still needs libpng because that one's small and hard to remove.) Only tested with make/gcc/linux." OFF)

set_property(GLOBAL PROPERTY USE_FOLDERS ${PROJECT_FOLDERS})

############################################################################
# Assemble compiler flags
############################################################################
include(CheckCXXCompilerFlag)

# Required for CMake >= 3.1.0 and Qt >= 5.7
set(CMAKE_CXX_STANDARD 14)

CHECK_CXX_COMPILER_FLAG("-std=gnu++14" USE_GCC_STD_14)
if(USE_GCC_STD_14)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++14")
endif()

# Enable link-time code generation. We have to do this manually because while
# there is a INTERPROCEDURAL_OPTIMIZATION cmake flag, it's only implemented
# for icc so far; https://cmake.org/Bug/view.php?id=15939
function(add_linker_flags)
	include(CMakeParseArguments)
	set(options optimized debug)
	set(oneValueArgs FLAGS)
	set(multiValueArgs MODULES)

	cmake_parse_arguments(_alf "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
	# Adds some linker flags to all optimized build configurations
	set(_configurations "")
	if(_alf_optimized)
		list(APPEND _configurations MINSIZEREL RELWITHDEBINFO RELEASE)
	endif()
	if(_alf_debug)
		list(APPEND _configurations DEBUG)
	endif()

	foreach(_module ${_alf_MODULES})
		string(TOUPPER "${_module}" _obj_type)
		foreach(_config ${_configurations})
			set(CMAKE_${_obj_type}_LINKER_FLAGS_${_config} "${CMAKE_${_obj_type}_LINKER_FLAGS_${_config}} ${_alf_FLAGS}" PARENT_SCOPE)
		endforeach()
	endforeach()
endfunction()

CHECK_CXX_COMPILER_FLAG("-flto" USE_GCC_STYLE_LTCG)
if(USE_GCC_STYLE_LTCG)
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -flto")
	set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} -flto")
	add_linker_flags(optimized MODULES exe shared FLAGS -flto)

	# Use GCC's ar and ranlib wrappers if necessary, because the plain ones 
	# don't understand lto objects without an explicit plugin parameter
	if(CMAKE_C_COMPILER MATCHES "gcc$")
		set(LTCG_NEEDS_AR_WRAPPER 1)
		set(LTCG_AR_WRAPPER_PREFIX "${CMAKE_C_COMPILER}")
	elseif(CMAKE_C_COMPILER MATCHES "cc$")
		set(LTCG_NEEDS_AR_WRAPPER 1)
		set(LTCG_AR_WRAPPER_PREFIX "gcc")
	else()
		set(LTCG_NEEDS_AR_WRAPPER 0)
	endif()

	if(LTCG_NEEDS_AR_WRAPPER)
		find_program(AR_WRAPPER "${LTCG_AR_WRAPPER_PREFIX}-ar")
		if (AR_WRAPPER)
			message("Using ${AR_WRAPPER} instead of ${CMAKE_AR} to support lto objects.")
			set(CMAKE_AR "${AR_WRAPPER}" CACHE FILEPATH "Path to an ar that supports lto objects." FORCE)
		endif()
		find_program(RANLIB_WRAPPER "${LTCG_AR_WRAPPER_PREFIX}-ranlib")
		if (RANLIB_WRAPPER)
			message("Using ${RANLIB_WRAPPER} instead of ${CMAKE_RANLIB} to support lto objects.")
			set(CMAKE_RANLIB "${RANLIB_WRAPPER}" CACHE FILEPATH "Path to a ranlib that supports lto objects." FORCE)
		endif()
	endif()
endif()

if(MSVC)
	if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
		# Set up some additional flags only if we're using the MS compiler,
		# and not the clang-based toolchain

		# Disable non-standard conversion from string literal to (nonconst) char*
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:strictStrings")

		# Activate edit-and-continue
		set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /ZI /Gy")
	endif()

	# Enable multi-core builds
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

	# Enable LTCG for release builds
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Ob2 /GL")
	set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /Ob2 /GL")
	add_linker_flags(optimized MODULES exe shared static FLAGS "/LTCG:incremental")

	# do not link the release CRT in debug builds
	set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:MSVCRT")
	set(HAVE_PRECOMPILED_HEADERS ON CACHE INTERNAL "Compiler supports precompiled headers")

	# Suppress warnings about "non-secure" functions
	add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS)
	# Disable warning C4244: 'conversion' conversion from 'type1' to 'type2', possible loss of data
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4244")
	# Disable warning C4267: 'var' : conversion from 'size_t' to 'type', possible loss of data (64 bit build only)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267")
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wextra-tokens -Wpointer-arith -Wno-cast-align -Wno-reorder -Wno-unused-parameter -Wnon-virtual-dtor -Woverloaded-virtual")
elseif(CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wredundant-decls -Wendif-labels -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -Winit-self -Wsign-promo -Wno-reorder -Wno-unused-parameter -Wnon-virtual-dtor -Woverloaded-virtual")
endif()

if(WIN32 AND MINGW)
	# Activate DEP and ASLR
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--nxcompat -Wl,--dynamicbase")
endif()

if(UNIX)
	add_definitions("-DOC_SYSTEM_DATA_DIR=\"${CMAKE_INSTALL_PREFIX}/share/games/openclonk\"")
endif()

if(APPLE)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fobjc-arc -headerpad_max_install_names")
endif()

############################################################################
# Check for compiler quirks and features
############################################################################
include(CheckCXXSourceCompiles)
include(RequireCXXSourceCompiles)
include(CheckCXXSymbolExists)

REQUIRE_CXX_SOURCE_COMPILES("#include <memory>\nint main() { std::unique_ptr<int> a; std::shared_ptr<int> b; }" HAVE_C11_SMART_PTRS)
REQUIRE_CXX_SOURCE_COMPILES("int main() { static_assert(true, \"\"); }" HAVE_STATIC_ASSERT)
REQUIRE_CXX_SOURCE_COMPILES("#include <memory>\nint main() { auto a = std::make_unique<int>(0); return !!a; }" HAVE_MAKE_UNIQUE)
REQUIRE_CXX_SOURCE_COMPILES("#include <utility>\ntemplate<std::size_t... Is> int foo(std::index_sequence<Is...>) {return 0;} int main() { return foo(std::index_sequence_for<int,int>{}); }" HAVE_INDEX_SEQUENCE)
REQUIRE_CXX_SOURCE_COMPILES("template<class... T> class C; int main() { return 0; }" HAVE_VARIADIC_TEMPLATES)

# g++'s libstdc++ doesn't properly support <regex> until 4.9.
# They ship a header that declares functions, but they don't ship an
# implementation for some things (like std::regex_iterator).
# This needs to test *linking*, not compilation; cmake does both at the same
# time, so the test below works.
REQUIRE_CXX_SOURCE_COMPILES("#include <regex>\nint main() { std::cregex_iterator ri; }" HAVE_WORKING_REGEX " If you are using gcc, please update to gcc 4.9.")
check_cxx_symbol_exists(vasprintf stdio.h HAVE_VASPRINTF)

############################################################################
# Check for required system headers
############################################################################
include(CheckIncludeFileCXX)
include(CheckIncludeFilesCXX)
CHECK_INCLUDE_FILE_CXX(direct.h HAVE_DIRECT_H)
CHECK_INCLUDE_FILE_CXX(io.h HAVE_IO_H)
CHECK_INCLUDE_FILE_CXX(locale.h HAVE_LOCALE_H)
CHECK_INCLUDE_FILE_CXX(share.h HAVE_SHARE_H)
CHECK_INCLUDE_FILE_CXX(signal.h HAVE_SIGNAL_H)
CHECK_INCLUDE_FILE_CXX(stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILE_CXX(inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE_CXX(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE_CXX(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE_CXX(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILE_CXX(execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILE_CXX(poll.h HAVE_POLL_H)
CHECK_INCLUDE_FILE_CXX(sys/inotify.h HAVE_SYS_INOTIFY_H)
CHECK_INCLUDE_FILE_CXX(sys/timerfd.h HAVE_SYS_TIMERFD_H)
CHECK_INCLUDE_FILE_CXX(sys/socket.h HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE_CXX(sys/eventfd.h HAVE_SYS_EVENTFD_H)
CHECK_INCLUDE_FILE_CXX(sys/file.h HAVE_SYS_FILE_H)
CHECK_INCLUDE_FILES_CXX("X11/Xlib.h;X11/extensions/Xrandr.h" HAVE_X11_EXTENSIONS_XRANDR_H)
CHECK_CXX_SOURCE_COMPILES("#include <getopt.h>\nint main(int argc, char * argv[]) { getopt_long(argc, argv, \"\", 0, 0); }" HAVE_GETOPT_H)

############################################################################
# Locate libraries
############################################################################
SET(JPEG_NAMES ${JPEG_NAMES} libjpeg jpeg-static)
if(NOT HEADLESS_ONLY)
	find_package(Freetype REQUIRED)
	include_directories(
		${FREETYPE_INCLUDE_DIRS})
	link_directories(
		${FREETYPE_LIBRARY_DIRS})
endif()
find_package(JPEG REQUIRED)
find_package(PNG REQUIRED)
find_package(ZLIB REQUIRED)
include_directories(
	${JPEG_INCLUDE_DIR}
	${PNG_INCLUDE_DIR}
	${ZLIB_INCLUDE_DIR})
if(CMAKE_SYSTEM MATCHES "Windows")
	message(STATUS "Using Win32 threading.")
else()
	find_package("Threads" REQUIRED)
	SET(HAVE_PTHREAD ${CMAKE_USE_PTHREADS_INIT} CACHE INTERNAL "libpthread available")
endif()

# FINDLIB works the same as find_library, but also marks the resulting var as
# advanced so it doesn't show in GUIs by default
macro(FINDLIB lib)
	find_library(${ARGV})
	mark_as_advanced(${lib})
endmacro(FINDLIB)

if(HAVE_EXECINFO_H)
	check_cxx_symbol_exists(backtrace execinfo.h HAVE_EXECINFO_WO_LINK)
	mark_as_advanced(HAVE_EXECINFO_WO_LINK)
	if(NOT HAVE_EXECINFO_WO_LINK)
		FINDLIB(EXECINFO_LIBRARY execinfo)
	endif()
endif()

if(NOT HAVE_GETOPT_H)
	include_directories(SYSTEM thirdparty/getopt)
	add_subdirectory(thirdparty/getopt)
	set_property(TARGET getopt PROPERTY FOLDER "Third-party libraries")
	set(GETOPT_LIBRARIES getopt)
endif()

# TinyXML
find_package(TinyXML)
if(NOT TinyXML_FOUND)
	add_subdirectory(thirdparty/tinyxml)
	set_property(TARGET tinyxml PROPERTY FOLDER "Third-party libraries")
	set(TinyXML_INCLUDE_DIRS thirdparty/tinyxml)
	set(TinyXML_LIBRARIES tinyxml)
	set(TinyXML_FOUND TRUE)
endif()

include_directories(SYSTEM ${TinyXML_INCLUDE_DIRS})

if(NOT HEADLESS_ONLY)
	find_package(OpenGL)

=== tools/install_mac/fancy-dmg/Makefile ===
#
# Build file for creating DMG files.
#
# The DMG packager looks for a template.dmg.bz2 for using as its 
# DMG template. If it doesn't find one, it generates a clean one.
#
# If you create a DMG template, you should make one containing all
# the files listed in $(SOURCE_FILES) below, and arrange everything to suit
# your style. The contents of the files themselves does not matter, so
# they can be empty (they will be overwritten later). 
#
# Remko Tronçon 
# http://el-tramo.be/about
# Licensed under the MIT License. See COPYING for details.


################################################################################
# Customizable variables
################################################################################

NAME ?= MyApp
VERSION ?= 0.1

SOURCE_DIR ?= src
SOURCE_FILES ?= MyApp.app README COPYING

TEMPLATE_DMG ?= template.dmg


################################################################################
# DMG building. No editing should be needed beyond this point.
################################################################################

MASTER_DMG=$(NAME)-$(VERSION).dmg
WC_DMG=wc.dmg
WC_DIR=wc

.PHONY: all
all: $(MASTER_DMG)

$(TEMPLATE_DMG): $(TEMPLATE_DMG).bz2
	bunzip2 -k $<

$(TEMPLATE_DMG).bz2: 
	@echo
	@echo --------------------- Generating empty template --------------------
	mkdir template
	hdiutil create -fs HFSX -layout SPUD -size 40m "$(TEMPLATE_DMG)" -srcfolder template -format UDRW -volname "$(NAME)" -quiet
	rmdir template
	bzip2 "$(TEMPLATE_DMG)"
	@echo

$(WC_DMG): $(TEMPLATE_DMG)
	cp $< $@

$(MASTER_DMG): $(WC_DMG) $(addprefix $(SOURCE_DIR)/,$(SOURCE_FILES))
	@echo
	@echo --------------------- Creating Disk Image --------------------
	mkdir -p $(WC_DIR)
	hdiutil attach "$(WC_DMG)" -noautoopen -quiet -mountpoint "$(WC_DIR)"
	for i in $(SOURCE_FILES); do  \
		rm -rf "$(WC_DIR)/$$i"; \
		ditto -rsrc "$(SOURCE_DIR)/$$i" "$(WC_DIR)/$$i"; \
	done

	#rm -f "$@"
	#hdiutil create -srcfolder "$(WC_DIR)" -format UDZO -imagekey zlib-level=9 "$@" -volname "$(NAME) $(VERSION)" -scrub -quiet

	# Why so complicated? Am I missing something? This doesn't even work... --PMW
	#WC_DEV=`hdiutil info | grep "$(WC_DIR)" | grep "Apple_HFS" | awk '{print $$1}'` && \
	hdiutil detach $$WC_DEV -quiet -force
	hdiutil detach wc -quiet -force

	rm -f "$(MASTER_DMG)"
	hdiutil convert "$(WC_DMG)" -quiet -format UDZO -imagekey zlib-level=9 -o "$@"
	rm -rf $(WC_DIR) $(WC_DMG)
	@echo

.PHONY: clean
clean:
	-rm -rf $(TEMPLATE_DMG) $(MASTER_DMG) $(WC_DMG)

=== debian/changelog ===
openclonk (8.0-2) unstable; urgency=medium

  * Use the Games team's Alioth list as the maintainer.
  * Disable the editor on arm. (Closes: #890264)

 -- Philipp Kern <pkern@debian.org>  Thu, 15 Feb 2018 22:58:32 +0100

openclonk (8.0-1) unstable; urgency=medium

  * New upstream version.
    - Remove Debian-specific patches: applied upstream.
    - Updated build dependencies to pull in qt5 for the editor.
    - Disable format string hardening to avoid a build failure on
      a custom printf wrapper.
  * Update Debian packaging:
    - Put the package under the Games team's umbrella.
    - Update VCS location to Salsa.
    - Let watch file point to Github.
    - Drop the explicit debug package.
    - Drop the Debian menu file, as a .desktop file is shipped.
    - Bump debhelper compat level to 10 for parallel building by default.

 -- Philipp Kern <pkern@debian.org>  Sun, 11 Feb 2018 17:01:35 +0100

openclonk (7.0-5) unstable; urgency=medium

  * Do not build-depend on OpenSSL, it is no longer needed.
    (Closes: #854868)
  * Honor SOURCE_DATE_EPOCH in the environment for the copyright
    year to make the build reproducible, thanks to Alexis Bienvenüe.
    (Closes: #823797)

 -- Philipp Kern <pkern@debian.org>  Thu, 29 Jun 2017 22:27:06 +0200

=== debian/control ===
Source: openclonk
Section: games
Priority: optional
Maintainer: Debian Games Packaging Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Philipp Kern <pkern@debian.org>
Build-Depends: debhelper (>= 10), cmake (>= 3.0.2), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev (>= 1.5.6), libgl1-mesa-dev, libpng-dev, libsdl2-dev, libsdl2-mixer-dev, libgtk-3-dev, qtbase5-dev, libjpeg-dev, zlib1g-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev, libopenal-dev, libalut-dev, libgtest-dev
Standards-Version: 4.1.3
Homepage: http://www.openclonk.org
VCS-Git: https://salsa.debian.org/games-team/openclonk.git
VCS-Browser: https://salsa.debian.org/games-team/openclonk

Package: openclonk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openclonk-data (= ${source:Version})
Description: multiplayer game of strategy, action and skill
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the OpenClonk engine.

Package: openclonk-data
Architecture: all
Depends: ${misc:Depends}
Recommends: openclonk
Description: multiplayer game of strategy, action and skill - data
 OpenClonk is a free multiplayer action game where you control clonks,
 small but witty and nimble humanoid beings. The game is mainly about
 mining, settling and fast-paced melees. OpenClonk is also not just a
 game but also a versatile 2D game engine that offers countless
 possibilities to make own mods.
 .
 This package contains the game data.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-format

%:
	dh $@ --buildsystem=cmake -Bbuild

CONFIG_ARGS := -DWITH_AUTOMATIC_UPDATE=0

# QT5 on arm uses GLES, which conflicts with the use of regular OpenGL.
ifeq (arm,$(shell dpkg-architecture -q DEB_HOST_ARCH_CPU))
	CONFIG_ARGS += -DQt5Widgets_FOUND=off
endif

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIG_ARGS)

override_dh_strip:
	dh_strip --dbgsym-migration='openclonk-dbg (<< 8.0-1~)'

override_dh_builddeb:
	dh_builddeb -- -Zxz

## openclonk 8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -158,7 +158,7 @@
 if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wextra-tokens -Wpointer-arith -Wno-cast-align -Wno-reorder -Wno-unused-parameter -Wnon-virtual-dtor -Woverloaded-virtual")
 elseif(CMAKE_COMPILER_IS_GNUCXX)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wredundant-decls -Wendif-labels -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -Winit-self -Wsign-promo -Wno-reorder -Wno-unused-parameter -Wnon-virtual-dtor -Woverloaded-virtual")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wredundant-decls -Wendif-labels -Wpointer-arith -Wcast-qual -Wcast-align -Wwrite-strings -Winit-self -Wsign-promo -Wno-reorder -Wno-unused-parameter -Wnon-virtual-dtor -Woverloaded-virtual -Wformat-security")
 endif()
 
 if(WIN32 AND MINGW)
@@ -177,6 +177,12 @@
 ############################################################################
 # Check for compiler quirks and features
 ############################################################################
+if(CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CROSSCOMPILING)
+	include(HandleGccCrossIncludePaths)
+	HANDLE_GCC_CROSS_INCLUDE_PATHS(CXX c++)
+	HANDLE_GCC_CROSS_INCLUDE_PATHS(C c)
+endif()
+
 include(CheckCXXSourceCompiles)
 include(RequireCXXSourceCompiles)
 include(CheckCXXSymbolExists)
@@ -272,12 +278,3 @@
 if(NOT TinyXML_FOUND)
 	add_subdirectory(thirdparty/tinyxml)
 	set_property(TARGET tinyxml PROPERTY FOLDER "Third-party libraries")
-	set(TinyXML_INCLUDE_DIRS thirdparty/tinyxml)
-	set(TinyXML_LIBRARIES tinyxml)
-	set(TinyXML_FOUND TRUE)
-endif()
-
-include_directories(SYSTEM ${TinyXML_INCLUDE_DIRS})
-
-if(NOT HEADLESS_ONLY)
-	find_package(OpenGL)

=== docs/Makefile ===
# German and English online docs:
#   make all
#   make install prefix=/path/to/webspace
# The offline docs:
#   make chm HHC=/path/to/hhc.exe

# Only English online docs, which can be partially updated:
#   make online-en
# The English offline doc:
#   make chm/en/Developer.chm HHC=/path/to/hhc.exe
# XML syntax check:
#   make check

# Extra Parameters for xsltproc can be given in the XSLTFLAGS variable.
# Use prefix to select the directory where the docs are to be installed

prefix = /tmp
HHC = hhc.exe
MKDIR_P = mkdir -p
CP = cp
CP_R = cp -r

stylesheet = clonk.xsl

# Sources:

# find all directories neither beginning nor contained within a directory beginning with a dot
sdk-dirs := $(shell find sdk -name '.*' -prune -o -type d -print)

# find all *.xml files recursively in sdk/
xmlfiles := $(sort $(shell find sdk -name '.*' -prune -o -name 'content.xml' -prune -o -name \*.xml -print))

# misc
extra-files := $(sort $(wildcard *.css *.php *.js images/*.*))
extra-files-chm := $(sort $(wildcard *.css *.js images/*.*))

# Targets:

# strip from all files the .xml, and add a .html
htmlfiles := $(addsuffix .html, $(basename $(xmlfiles)))

# The translated files and directories
sdk-de-dirs := $(subst sdk, sdk-de, $(sdk-dirs))

# For openclonk.org
online-dirs := $(foreach lang, en de, $(addprefix online/$(lang)/, $(sdk-dirs) images))
online-sdk-files := $(foreach lang, en de, $(addprefix online/$(lang)/, $(htmlfiles) sdk/content.html))
online-extra-files := $(foreach lang, en de, $(addprefix online/$(lang)/, $(extra-files)))

# For Entwickler.chm
chm-dirs := $(foreach lang, en de, $(addprefix chm/$(lang)/, . $(sdk-dirs) images))

.PHONY: all online-en chm install check clean

all: $(sdk-de-dirs) $(online-dirs) $(online-sdk-files) $(online-extra-files)

online-en: $(addprefix online/en/, $(sdk-dirs) images $(htmlfiles) sdk/content.html $(extra-files))

chm: $(sdk-de-dirs) $(chm-dirs) chm/en/Developer.chm chm/de/Entwickler.chm

install: all
	$(MKDIR_P) $(prefix)
	$(CP_R) online/* $(prefix)

check:
	@xmllint --noblanks --noout --valid $(xmlfiles)

clean:
	rm -f *.mo Entwickler.chm Developer.chm doku.pot sdk/content.xml
	rm -rf online sdk-de chm

sdk/content.xml: sdk/content.xml.in $(xmlfiles) build_contents.py experimental.py
	@echo generate $@
	@python2 build_contents.py $(xmlfiles)

chm/en/Output.hhp: $(xmlfiles) chm/en/. build_hhp.py Template.hhp
	@echo generate $@
	@python2 build_hhp.py $@ Template.hhp $(xmlfiles)
chm/de/Output.hhp: $(xmlfiles) chm/de/. build_hhp.py Template.de.hhp
	@echo generate $@
	@python2 build_hhp.py $@ Template.de.hhp $(xmlfiles)

$(sdk-de-dirs) $(online-dirs) $(chm-dirs):
	mkdir -p $@

doku.pot: $(xmlfiles) extra-strings.xml sdk/content.xml.in xml2po.py clonk.py
	@echo extract strings to $@
	@python2 xml2po.py -e -m clonk -o $@ $(xmlfiles) extra-strings.xml sdk/content.xml.in

%.po: doku.pot
	@echo update $@
#	@msgmerge --no-wrap -w 1 -U $@ $<
	@msgmerge --no-wrap -w 1 -o $@ $@ $<

%.mo: %.po
	@echo compile $@
	@msgfmt --statistics -o $@ $<

sdk-de/%.xml: sdk/%.xml de.mo xml2po.py clonk.py
	@echo generate $@
	@python2 xml2po.py -e -m clonk -t de.mo -o $@ $<

define run-xslt
@echo generate $@
@xsltproc -o $@ --param chm $(chm) --param fileext "'.html'" $(XSLTFLAGS) $(stylesheet) $<
endef
online/%: chm=0
chm/%: chm=1
online/en/sdk/%.html: sdk/%.xml $(stylesheet) ; $(run-xslt)
online/de/sdk/%.html: sdk-de/%.xml $(stylesheet) ; $(run-xslt)
chm/en/sdk/%.html: sdk/%.xml $(stylesheet) ; $(run-xslt)
chm/de/sdk/%.html: sdk-de/%.xml $(stylesheet) ; $(run-xslt)
chm/en/Output.hhc: stylesheet=hhc.xsl
chm/de/Output.hhc: stylesheet=hhc.xsl
chm/en/Output.hhc: sdk/content.xml hhc.xsl ; $(run-xslt)
chm/de/Output.hhc: sdk-de/content.xml hhc.xsl ; $(run-xslt)
chm/en/Output.hhk: stylesheet=hhk.xsl
chm/de/Output.hhk: stylesheet=hhk.xsl
chm/en/Output.hhk: sdk/content.xml hhk.xsl ; $(run-xslt)
chm/de/Output.hhk: sdk-de/content.xml hhk.xsl ; $(run-xslt)

$(filter online/en/%, $(online-extra-files)): online/en/%: %
	$(CP) $< $@
$(filter online/de/%, $(online-extra-files)): online/de/%: %
	$(CP) $< $@
$(addprefix chm/en/, $(extra-files-chm)): chm/en/%: %
	$(CP) $< $@
$(addprefix chm/de/, $(extra-files-chm)): chm/de/%: %
	$(CP) $< $@

chm/en/Developer.chm: chm/en/Output.hhp chm/en/Output.hhk chm/en/Output.hhc $(addprefix chm/en/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
	! "$(HHC)" $<
chm/de/Entwickler.chm: chm/de/Output.hhp chm/de/Output.hhk chm/de/Output.hhc $(addprefix chm/de/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
	! "$(HHC)" $<

=== tests/CMakeLists.txt ===
# OpenClonk, http://www.openclonk.org
#
# Copyright (c) 2013-2015, The OpenClonk Team and contributors
#
# Distributed under the terms of the ISC license; see accompanying file
# "COPYING" for details.
#
# "Clonk" is a registered trademark of Matthes Bender, used with permission.
# See accompanying file "TRADEMARK" for details.
#
# To redistribute this file separately, substitute the full license texts
# for the above references.

# used by c4script and by the unit tests
set(C4SCRIPT_SOURCES
	../include/c4script/c4script.h
	../src/C4Include.cpp
	../src/script/C4ScriptStandalone.cpp
    ../src/script/C4ScriptStandaloneStubs.cpp
)

# Look for GTest and GMock
# GMock's source package ships GTest too, so look for it first
find_path(GMOCK_ROOT
    NAMES "gmock-all.cc" "src/gmock-all.cc" "gmock/gmock-all.cc"
    PATHS "/usr/src/gmock"
    )
find_path(GMOCK_INCLUDE_DIR
    NAMES "gmock/gmock.h"
    HINTS "${GMOCK_ROOT}"
    PATH_SUFFIXES "include"
    )
find_file(GMOCK_SOURCE_ALL
    NAMES "gmock-all.cc"
    HINTS "${GMOCK_ROOT}"
    PATH_SUFFIXES "src" "gtest"
    NO_DEFAULT_PATH
    )

find_path(GTEST_ROOT
    NAMES "src/gtest-all.cc" "gtest/gtest-all.cc"
    PATHS "${GMOCK_ROOT}" "/usr/src/gtest"
    )
find_path(GTEST_INCLUDE_DIR
    NAMES "gtest/gtest.h"
    HINTS "${GTEST_ROOT}"
    PATH_SUFFIXES "include"
    )
find_file(GTEST_SOURCE_ALL
    NAMES "gtest-all.cc"
    HINTS "${GTEST_ROOT}"
    PATH_SUFFIXES "src" "gtest"
    NO_DEFAULT_PATH
    )

if (GMOCK_SOURCE_ALL AND GMOCK_INCLUDE_DIR)
    add_library(gmock STATIC
        "${GMOCK_SOURCE_ALL}"
        "${GMOCK_INCLUDE_DIR}/gmock/gmock.h"
        )
	set_property(TARGET gmock PROPERTY FOLDER "Third-party libraries")
    if (GMOCK_ROOT)
        include_directories("${GMOCK_ROOT}")
    endif()
    include_directories("${GMOCK_INCLUDE_DIR}")
    set(GMOCK_FOUND 1)
endif()

if (GTEST_SOURCE_ALL AND GTEST_INCLUDE_DIR)
    add_library(gtest STATIC
        "${GTEST_SOURCE_ALL}"
        "${GTEST_INCLUDE_DIR}/gtest/gtest.h"
        )
	set_property(TARGET gtest PROPERTY FOLDER "Third-party libraries")
    if (GTEST_ROOT)
        include_directories("${GTEST_ROOT}")
    endif()
     if(HAVE_PTHREAD)
        target_link_libraries(gtest pthread)
    endif()
    include_directories("${GTEST_INCLUDE_DIR}")
    set(GTEST_FOUND 1)
endif()

include(CMakeParseArguments)
function(create_test testName)
    set(oneValueArgs "")
    set(multiValueArgs SOURCES LIBRARIES)
    CMAKE_PARSE_ARGUMENTS(CT "" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
    add_executable("${testName}" EXCLUDE_FROM_ALL
		${CT_SOURCES}
		TestLog.cpp
		TestLog.h
		main.cpp
	)
	target_include_directories("${testName}" PRIVATE "${CMAKE_CURRENT_LIST_DIR}")
	set_property(TARGET "${testName}" PROPERTY FOLDER "Testing")
    target_link_libraries("${testName}" gtest gmock ${CT_LIBRARIES})
    add_test(NAME "${testName}" COMMAND "${testName}")
endfunction()

if (GTEST_FOUND AND GMOCK_FOUND)
    enable_testing()

    create_test(StdMeshMath
        SOURCES
        "../src/lib/StdMeshMath.cpp"
        "../src/lib/StdMeshMath.h"
        "math/StdMeshVectorTest.cpp"
        "math/StdMeshQuaternionTest.cpp"
        )

    AUX_SOURCE_DIRECTORY("${CMAKE_CURRENT_LIST_DIR}" TESTS_SOURCES)
    add_executable(tests EXCLUDE_FROM_ALL ${TESTS_SOURCES} ${C4SCRIPT_SOURCES})
	set_property(TARGET "tests" PROPERTY FOLDER "Testing")
    target_link_libraries(tests gtest libc4script libmisc)
    if(UNIX AND NOT APPLE)
	    target_link_libraries(tests rt)
    endif()
    if(WIN32)
        target_link_libraries(tests winmm)
    endif()

    create_test(aul_test
        SOURCES
            aul/AulTest.cpp
			aul/AulTest.h
			aul/AulMathTest.cpp
			aul/AulPredefinedFunctionTest.cpp
			aul/AulDeathTest.cpp
			aul/AulDiagnosticsTest.cpp
			aul/AulSyntaxTest.cpp
			aul/AulSyntaxTestDetail.h
			aul/ErrorHandler.h
            ../src/script/C4ScriptStandaloneStubs.cpp
            ../src/script/C4ScriptStandalone.cpp
        LIBRARIES
            libmisc
            libc4script)
else()
    set(_gtest_missing "")
    if (NOT GTEST_INCLUDE_DIR)
        set(_gtest_missing "${_gtest_missing} gtest/gtest.h")
    endif()
    if (NOT GTEST_SOURCE_ALL)
        set(_gtest_missing "${_gtest_missing} gtest-all.cc")
    endif()
    if (NOT GMOCK_INCLUDE_DIR)
        set(_gtest_missing "${_gtest_missing} gmock/gmock.h")
    endif()
    if (NOT GMOCK_SOURCE_ALL)
        set(_gtest_missing "${_gtest_missing} gmock-all.cc")
    endif()
    message(STATUS "Could NOT find GTest/GMock (missing:${_gtest_missing})")
endif()

=== thirdparty/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)
project(backward CXX)

include(BackwardConfig.cmake)

set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic-errors")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

###############################################################################
# TESTS
###############################################################################

if(BACKWARD_TESTS)
	enable_testing()

	add_library(test_main SHARED test/_test_main.cpp)

	macro(backward_add_test src)
		get_filename_component(name ${src} NAME_WE)
		set(test_name "test_${name}")

		add_executable(${test_name} ${src} ${ARGN})

		target_link_libraries(${test_name} PRIVATE Backward::Backward test_main)

		add_test(NAME ${name} COMMAND ${test_name})
	endmacro()

	# Tests without backward.cpp
	set(TESTS
		test
		stacktrace
		rectrace
		select_signals
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp)
	endforeach()

	# Tests with backward.cpp
	set(TESTS
		suicide
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp ${BACKWARD_ENABLE})
	endforeach()
endif()

install(
    FILES "backward.hpp"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)
install(
    FILES "BackwardConfig.cmake"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/backward
)

=== thirdparty/blake2/CMakeLists.txt ===
# OpenClonk, http://www.openclonk.org
#
# Copyright (c) 2018, The OpenClonk Team and contributors
#
# Distributed under the terms of the ISC license; see accompanying file
# "COPYING" for details.
#
# "Clonk" is a registered trademark of Matthes Bender, used with permission.
# See accompanying file "TRADEMARK" for details.
#
# To redistribute this file separately, substitute the full license texts
# for the above references.

add_library(blake2 STATIC
	blake2.h
)

target_sources(blake2
	PRIVATE
	blake2b.c
	blake2bp.c
	blake2s.c
	blake2sp.c
	blake2xb.c
	blake2xs.c
	blake2b-load-sse2.h
	blake2b-load-sse41.h
	blake2b-round.h
	blake2s-load-sse2.h
	blake2s-load-sse41.h
	blake2s-load-xop.h
	blake2s-round.h
	blake2-config.h
	blake2-impl.h
)

include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG("-msse2" HAVE_CFLAG_MSSE2)
target_compile_definitions(blake2 PRIVATE -DHAVE_SSE2)
if(HAVE_CFLAG_MSSE2)
	target_compile_options(blake2 PUBLIC -msse2)
endif()
target_include_directories(blake2 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== thirdparty/getopt/CMakeLists.txt ===
add_library(getopt
	getopt.c
	getopt.h
	getopt_long.c
)

=== thirdparty/tinyxml/CMakeLists.txt ===
add_library(tinyxml
	tinystr.cpp
	tinystr.h
	tinyxml.cpp
	tinyxml.h
	tinyxmlerror.cpp
	tinyxmlparser.cpp
)

if(GTK3_FOUND)
	target_include_directories(tinyxml PRIVATE ${GTK3_INCLUDE_DIRS})
endif()

=== tools/install_mac/Makefile ===

# Project data
NAME = OpenClonk
VERSION = 2.0

# Assume default XCode output directory
SOURCE_DIR = ../../Release
SOURCE_FILES = openclonk.app

TEMPLATE_DMG = template.dmg

include fancy-dmg/Makefile

=== debian/changelog ===
openclonk (8.1-5) unstable; urgency=medium

  * QA upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113354)
  * Backport upstream fix for FTBFS with miniupnpc 2.3.
  * Fix FTBFS with GoogleTest 1.17.0. (Closes: #1114245)
  * Workaround parallel build issue. (Closes: #1104391)

 -- Adrian Bunk <bunk@debian.org>  Tue, 07 Oct 2025 18:30:37 +0300

openclonk (8.1-4) unstable; urgency=medium

  * QA upload.

  [ Georges Khaznadar ]
  * bumped standards: debhelper-compat (=13), Standards-Version: 4.6.2
  * added the path usr/share/appdata/openclonk.appdata.xml to the file
    d/openclonk.install, to please dh_missing, which is triggered by
    debhelper level 13.

  [ Boyuan Yang ]
  * debian/compat: Dropped.
  * debian/patches: Refresh patches with "gbp pq".
  * debian/upstream/metadata: Add Repository and Repository-Browse.
  * debian/control: Update obsolete package dependency:
    libfreetype6-dev => libfreetype-dev, libgl1-mesa-dev => libgl-dev.

 -- Boyuan Yang <byang@debian.org>  Mon, 04 Sep 2023 15:37:46 -0400

openclonk (8.1-3) unstable; urgency=medium

  * QA upload.
  * Fix FTCBFS: Pass -DIMPORT_NATIVE_TOOLS=path-to-native-build.
    Thanks to Helmut Grohne. (Closes: #996841)
  * Fix ftbfs on GCC-11. (Closes: #984274)

 -- Bo YU <tsu.yubo@gmail.com>  Fri, 23 Dec 2022 21:49:46 +0800

openclonk (8.1-2) unstable; urgency=medium

  * Remove myself from Uploaders and orphan the package.
  * Update Debian packaging:
    - Point Homepage to the https version of the site.
    - openclonk-data: Mark as Multi-Arch: foreign
    - Set Rules-Requires-Root: no.

 -- Philipp Kern <pkern@debian.org>  Sun, 03 Jan 2021 22:24:57 +0100

openclonk (8.1-1) unstable; urgency=medium

  * New upstream version.
    - Reenable format string hardening (fixed upstream).
    - Use the system-provided blake2 rather than the vendored copy.

 -- Philipp Kern <pkern@debian.org>  Sun, 18 Mar 2018 14:47:44 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,39 @@
 Source: openclonk
 Section: games
 Priority: optional
-Maintainer: Debian Games Packaging Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Philipp Kern <pkern@debian.org>
-Build-Depends: debhelper (>= 10), cmake (>= 3.0.2), libx11-dev, libxxf86vm-dev, libxrandr-dev, libxpm-dev, libglew-dev (>= 1.5.6), libgl1-mesa-dev, libpng-dev, libsdl2-dev, libsdl2-mixer-dev, libgtk-3-dev, qtbase5-dev, libjpeg-dev, zlib1g-dev, libupnp-dev, libfreetype6-dev, libboost-regex-dev, imagemagick, libtinyxml-dev, libopenal-dev, libalut-dev, libgtest-dev
-Standards-Version: 4.1.3
-Homepage: http://www.openclonk.org
-VCS-Git: https://salsa.debian.org/games-team/openclonk.git
-VCS-Browser: https://salsa.debian.org/games-team/openclonk
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends: debhelper-compat (= 13),
+ cmake,
+ libx11-dev,
+ libxxf86vm-dev,
+ libxrandr-dev,
+ libxpm-dev,
+ libglew-dev,
+ libgl-dev,
+ libpng-dev,
+ libpng-dev:native,
+ libsdl2-dev,
+ libsdl2-mixer-dev,
+ libgtk-3-dev,
+ qtbase5-dev,
+ libjpeg-dev,
+ libjpeg-dev:native,
+ zlib1g-dev,
+ zlib1g-dev:native,
+ libupnp-dev,
+ libfreetype-dev,
+ libboost-regex-dev,
+ imagemagick,
+ libtinyxml-dev,
+ libopenal-dev,
+ libalut-dev,
+ libgtest-dev,
+ libb2-dev,
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: https://www.openclonk.org
+Vcs-Git: https://salsa.debian.org/games-team/openclonk.git
+Vcs-Browser: https://salsa.debian.org/games-team/openclonk
 
 Package: openclonk
 Architecture: any
@@ -23,6 +49,7 @@
 
 Package: openclonk-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: openclonk
 Description: multiplayer game of strategy, action and skill - data

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,5 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-format
 
 %:
 	dh $@ --buildsystem=cmake -Bbuild
@@ -14,10 +12,20 @@
 endif
 
 override_dh_auto_configure:
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_configure --builddirectory=build-native -- -DHEADLESS_ONLY=ON
+	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_build --builddirectory=build-native -- c4group
+	dh_auto_configure -- $(CONFIG_ARGS) -DIMPORT_NATIVE_TOOLS=../build-native/NativeToolsExport.cmake
+else
 	dh_auto_configure -- $(CONFIG_ARGS)
+endif
+
+override_dh_auto_build:
+	dh_auto_build --no-parallel -- groups
+	dh_auto_build
 
 override_dh_strip:
 	dh_strip --dbgsym-migration='openclonk-dbg (<< 8.0-1~)'
 
 override_dh_builddeb:
-	dh_builddeb -- -Zxz
+	dh_builddeb

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/openclonk-$1\.tar\.gz/ \
  https://github.com/openclonk/openclonk/tags .*/v?(\d\S+)\.tar\.gz
